#include <bits/stdc++.h>

using namespace std;

int main()
{
    int t;
    long long n;
    cin>>t;
    long long a[30000],b[30000];
    int niz[t];
    for(int i=0;i<t;i++){
        cin>>n;
        int sa,sb,sj,sk;
        for(int j1=0;j1<n;j1++){
            int j=j1;
            cin>>a[j];
            if(a[j]!=0){
                sa=a[j];
                sj=j;
            }
        }
        for(int k1=0;k1<n;k1++){
            int k=k1;
            cin>>b[k];
            if(b[k]!=0){
                sb=b[k];
                sk=k;
            }
        }
        if(sa!=sb && sk==sj && n<=2){
            niz[i]=0;
        }
        else if(sa==sb && sk==sj){
            niz[i]=1;
        }
        else if(n==2 && sa==sb && sk!=sj){
            niz[i]=0;
        }
        else if(sa==sb or sa==-sb){
            niz[i]=1;
        }
        else{
            niz[i]=0;
        }
    }
    for(int m=0;m<t;m++){
        if(niz[m]==1){
            cout<<"DA"<<endl;
        }
        else{
            cout<<"NE"<<endl;
        }
    }
    return 0;
}